
%   this is phase 4 of the mean shift algorithm. 
%   it checks if the cluster centers' candidates are not too close to each
%   other

function centers = getClusterCenters( candidates, h )

[m dim] = size(candidates);

group = [1 : m];
for (i = 1 : m-1)
    for (j = i+1 : m)
        if (distance(candidates(i, :), candidates(j, :)) < h)
            g1 = group(i);
            g2 = group(j);
            for (k = 1 : m)
                if (group(k) == g2)
                    group(k) = g1;
                end
            end %for - k
        end %if
    end %for - j
end % for - i

tempCenters = zeros( m, dim );
count = zeros(1, m);
for ( i = 1 : m )
    tempCenters(group(i), :) = tempCenters(group(i), :) + candidates(i, :);
    count(group(i)) = count(group(i)) + 1;
end

groupsSize = 0;
for ( i = 1 : m )
    if ( count(i) ~= 0 )
        groupsSize = groupsSize + 1;
        tempCenters(i, :) = tempCenters(i, :) / count(i);
    end
end

j = 1;
centers = zeros(groupsSize, dim);
for ( i = 1 : m )
    if ( tempCenters(i) ~= 0 )
        centers(j, :) = tempCenters(i, :);
        j = j + 1;
    end
end

     

            
            