

function newCandidates = perturbCandidates( candidates, perturbSize )

[m dim] = size(candidates);

newCandidates = candidates;%zeros(m, dim);
for (i=1 : m)
    a = newCandidates(i, :) + randPerturb(dim, perturbSize);
    newCandidates(i,:) = round(a);
end


function p = randPerturb( dim, perturbSize )

p = rand(1, dim);
for (i=1 : dim)
    if (p(i) < 0.5)
        p(i) = p(i) - 1;
    end
    p(i) = p(i) * perturbSize;
end
