
%   this function read the picture and change it to black&white and scale
%   it to double and [0, 1]

function newPic = readPic(picFile, picFormat)

pic = double(imread(picFile, picFormat));

[I J color] = size(pic);
if ( color == 1 )   %gray scale
    newPic = pic / 255;
else                % color
    newPic = (pic(:, :, 1) + pic(:, :, 2) + pic(:, :, 3)) / (3*255);
end