
%   this function doesn't randomized a set of point as the mean shift
%   algorithm says, but scatter all the sample set uniformly on the
%   picture

function  set =  sampleSet( pic, m)

[I J] = size(pic);
mi = floor(I / sqrt(m));
mj = floor(J / sqrt(m));
set = zeros(m, 2);
k = 1;
for( i = mi/2+1 : mi+1 : I )
    for( j = mj/2+1 : mj+1 : J )
        set(k, :) = [i, j];
        k = k + 1;
    end
end
    