
%   this function claculate the cluster center, but it's now considering if
%   another shape hides part of the shape it wants to find its center

function [clusterX ,clusterY] = findNewCenter(labels, clusterX, clusterY, clusterLabel, numTests)%, h clusterLabels)

clusterLabels = findAllLabels(labels, clusterX, clusterY, clusterLabel, numTests );

[I J] = size(labels);
[tmp num] = size(clusterLabels);
count = 0;
mean = [0 0];

for ( i = 1 : I )
    for ( j = 1 : J )
        for  (k = 1 : num )
            if ( labels(i, j) == clusterLabels(k) )
                mean = mean + [i j];
                count = count + 1;
            end
        end
    end
end

mean = mean / count;
clusterX = round(mean(2));
clusterY = round(mean(1));

function res = has(allLabels, label )
[tmp I] = size(allLabels);
res = 0;

for ( i = 1 : I )
    if ( allLabels(i) == label )
        res = 1;
        return;
    end
end


function allLabels = findAllLabels(labels, clusterX, clusterY, clusterLabel, numTests )
allLabels = clusterLabel;
[I J] = size(labels);
lastLabel = 0;

for ( angle = 0 : 2*pi/numTests : 2*pi )
    flag = 1;
    flagLast = 0;
    r = 0;
    lastL = 0;
    while ( flag == 1 )
        x = clusterX + round(r*sin(angle));
        y = clusterY + round(r*cos(angle));
        if  (x >= 1 && x <= J && y >= 1 && y <= I )
            if ( labels(y, x) == clusterLabel )
                lastL = 0;
            else
                if (  has(lastL, labels(y, x)) == 0 ) % not has
                    lastL = [lastL labels(y, x)];
                end
            end
            if (  has(allLabels, labels(y, x)) == 0 ) % not has
                allLabels = [allLabels labels(y, x)];
            end
            r = r + 1;
        else
            flag = 0;
        end % if else
    end % while
    lastLabel = [lastLabel lastL];
end % for angle

allLabels = remove(allLabels, lastLabel);

function allLabels = remove(allLabels, lastLabels)
[tmp I] = size(lastLabels);

for ( i = 2 : I )
    [tmp J] = size(allLabels);
    for  ( j = 1 : J )
        if ( allLabels(j) == lastLabels(i) )
            allLabels = [allLabels(1:j-1) allLabels(j+1:J)];
            break;
        end
    end
end
