
%   this function divide the range [0, 1] such that every cluster get a 
%   differnt color, and plot all of them

function plotClusters(labels, centers)%pic, labels, centers)
[I J] = size(labels);
[p, tmp] = size(centers);

color = zeros(1, p);
for ( i = 1 : p )
    color(i) = 1/(p-1) * (i-1);
end

newPic = zeros(I, J);
for ( i = 1 : I )
    for ( j = 1 : J )
        newPic(i, j) = color( labels(i, j) );
    end
end

figure
imshow(newPic);
