
%   find the mean of a sphere with radius h around the point p, considering
%   the distance in the picture (pixels) and the distance in the colors.

function mean = sphereMean(pic, p, h)

[I J] = size(pic);
mean = [0 0];
count = 0;

for ( i = p(1)-h : p(1)+h )
    for ( j = p(2)-h : p(2)+h )
        if( distance([i j], p) <= h && i>=1 && i<=I && j>=1 &&j<=J)
            mean = mean + ([i j] - p) * pic(i,j);
            count = count + 1;
        end
    end
end
mean = p + round(mean/count);
            
